Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 6851)
@@ -1636,22 +1616,52 @@
          BPE002 = 5.3661089288e-04_wp
          !
-      CASE( 1 )                        !==  Simplified EOS     ==!
+      CASE( np_seos )                        !==  Simplified EOS  ==!
          IF(lwp) THEN
             WRITE(numout,*)
-            WRITE(numout,*) '          use of simplified eos:    rhd(dT=T-10,dS=S-35,Z) = '
-            WRITE(numout,*) '             [-a0*(1+lambda1/2*dT+mu1*Z)*dT + b0*(1+lambda2/2*dT+mu2*Z)*dS - nu*dT*dS]/rau0'
+            WRITE(numout,*) '          use of simplified eos (S-EOS):     '
+            WRITE(numout,*) '   rhd(dT=CT-T0,dS=SA-35,Z) = [ - (a0 + cb/2*dT + th*Z )*dT + b0*dS ] / rau0'
+            WRITE(numout,*) '          with'
+            WRITE(numout,*) '             linear thermal expansion coef.   a0 = rn_a0 = ', rn_a0
+            WRITE(numout,*) '             haline  contraction coef.        b0 = rn_b0 = ', rn_b0
+            WRITE(numout,*) '             cabbeling coef.                  cb = rn_cb = ', rn_cb
+            WRITE(numout,*) '             reference temperature coef.      T0 = rn_t0 = ', rn_t0
+            WRITE(numout,*) '             thermobaric coef.                th = rn_th = ', rn_th
             WRITE(numout,*)
-            WRITE(numout,*) '             thermal exp. coef.    rn_a0      = ', rn_a0
-            WRITE(numout,*) '             saline  cont. coef.   rn_b0      = ', rn_b0
-            WRITE(numout,*) '             cabbeling coef.       rn_lambda1 = ', rn_lambda1
-            WRITE(numout,*) '             cabbeling coef.       rn_lambda2 = ', rn_lambda2
-            WRITE(numout,*) '             thermobar. coef.      rn_mu1     = ', rn_mu1
-            WRITE(numout,*) '             thermobar. coef.      rn_mu2     = ', rn_mu2
-            WRITE(numout,*) '             2nd cabbel. coef.     rn_nu      = ', rn_nu
-            WRITE(numout,*) '               Caution: rn_beta0=0 incompatible with ddm parameterization '
          ENDIF
-         !
-      CASE DEFAULT                     !==  ERROR in nn_eos  ==!
-         WRITE(ctmp1,*) '          bad flag value for nn_eos = ', nn_eos
+         IF( rn_b0 == 0._wp )   CALL ctl_warn('eos_init: rn_b0=0 incompatible with ddm parameterization ')
+         IF( rn_a0 == 0._wp .AND. rn_cb == 0._wp )   CALL ctl_stop('eos_init:  S-EOS need non zero a0 or cb')
+         !
+         l_useCT = .TRUE.                 ! Use Conservative Temperature 
+         rSA2SP  = 35._wp / 35.16504_wp   ! model salinity is Absolute Salinity (= conversion from SA to SP)
+         !
+         SA0 = rn_a0
+         SB0 = rn_b0
+         SCB = rn_cb
+         ST0 = rn_t0
+         STH = rn_th
+         !
+      CASE( np_leos )                        !==  Linear EOS     ==!
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) '          use of linear eos (L-EOS):    '
+            WRITE(numout,*) '   rhd(dT=CT-10,dS=SA-35) = [ - al*dT + bl*dS ] / rau0'
+            WRITE(numout,*) '          with'
+            WRITE(numout,*) '             thermal expansion   coef.   al = rn_al = ', rn_al
+            WRITE(numout,*) '             haline  contraction coef.   bl = rn_bl = ', rn_bl
+            WRITE(numout,*)
+         ENDIF
+         IF( rn_bl == 0._wp )   CALL ctl_warn('eos_init: rn_bl=0 incompatible with ddm parameterization ')
+         !
+         l_useCT = .TRUE.                 ! Use Conservative Temperature
+         rSA2SP  = 35._wp / 35.16504_wp   ! model salinity is Absolute Salinity (= conversion from SA to SP)
+         !
+         SA0 =  rn_al
+         SB0 =  rn_bl
+         SCB =  0._wp
+         ST0 = 10._wp
+         STH =  0._wp
+         !
+      CASE DEFAULT                     !==  ERROR in neos  ==!
+         WRITE(ctmp1,*) '          bad flag value for neos = ', neos, '. You should never see this error'
          CALL ctl_stop( ctmp1 )
          !
@@ -1663,10 +1673,19 @@
       r1_rau0_rcp = 1._wp / rau0_rcp 
       !
+      IF(lwp) THEN
+         IF( l_useCT )   THEN
+            WRITE(numout,*) '          The ocean model uses Conservative Temperature and Absolute Salinity'
+            WRITE(numout,*) '          Important: model initialization must be with CT and SA fields'
+         ELSE
+            WRITE(numout,*) '          model use Potential Temperature and Practical salinity'
+         ENDIF
+      ENDIF
+      !
       IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '          volumic mass of reference           rau0  = ', rau0   , ' kg/m^3'
-      IF(lwp) WRITE(numout,*) '          1. / rau0                        r1_rau0  = ', r1_rau0, ' m^3/kg'
-      IF(lwp) WRITE(numout,*) '          ocean specific heat                 rcp   = ', rcp    , ' J/Kelvin'
-      IF(lwp) WRITE(numout,*) '          rau0 * rcp                       rau0_rcp = ', rau0_rcp
-      IF(lwp) WRITE(numout,*) '          1. / ( rau0 * rcp )           r1_rau0_rcp = ', r1_rau0_rcp
+      IF(lwp) WRITE(numout,*) '          density of reference               rau0 = ', rau0   , ' kg/m^3'
+      IF(lwp) WRITE(numout,*) '          1. / rau0                       r1_rau0 = ', r1_rau0, ' m^3/kg'
+      IF(lwp) WRITE(numout,*) '          ocean specific heat                 rcp = ', rcp    , ' J/Kelvin'
+      IF(lwp) WRITE(numout,*) '          rau0 * rcp                     rau0_rcp = ', rau0_rcp
+      IF(lwp) WRITE(numout,*) '          1. / ( rau0 * rcp )         r1_rau0_rcp = ', r1_rau0_rcp
       !
    END SUBROUTINE eos_init
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/trabbl.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 6851)
@@ -122,7 +122,6 @@
          !
          CALL tra_bbl_dif( tsb, tsa, jpts )
-         IF( ln_ctl )  &
-         CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' bbl_ldf  - Ta: ', mask1=tmask, &
-            &          tab3d_2=tsa(:,:,:,jp_sal), clinfo2=           ' Sa: ', mask2=tmask, clinfo3='tra' )
+         IF( ln_ctl )   CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' bbl_ldf  - Ta: ', mask1=tmask,   &
+            &                         tab3d_2=tsa(:,:,:,jp_sal), clinfo2=           ' Sa: ', mask2=tmask, clinfo3='tra' )
          ! lateral boundary conditions ; just need for outputs
          CALL lbc_lnk( ahu_bbl, 'U', 1. )     ;     CALL lbc_lnk( ahv_bbl, 'V', 1. )
@@ -255,5 +254,5 @@
          DO jj = 1, jpjm1
             DO ji = 1, jpim1            ! CAUTION start from i=1 to update i=2 when cyclic east-west
-               IF( utr_bbl(ji,jj) /= 0.e0 ) THEN            ! non-zero i-direction bbl advection
+               IF( utr_bbl(ji,jj) /= 0._wp ) THEN            ! non-zero i-direction bbl advection
                   ! down-slope i/k-indices (deep)      &   up-slope i/k indices (shelf)
                   iid  = ji + MAX( 0, mgrhu(ji,jj) )   ;   iis  = ji + 1 - MAX( 0, mgrhu(ji,jj) )
@@ -277,5 +276,5 @@
                ENDIF
                !
-               IF( vtr_bbl(ji,jj) /= 0.e0 ) THEN            ! non-zero j-direction bbl advection
+               IF( vtr_bbl(ji,jj) /= 0._wp ) THEN            ! non-zero j-direction bbl advection
                   ! down-slope j/k-indices (deep)        &   up-slope j/k indices (shelf)
                   ijd  = jj + MAX( 0, mgrhv(ji,jj) )     ;   ijs  = jj + 1 - MAX( 0, mgrhv(ji,jj) )
@@ -452,5 +451,5 @@
                   zgdrho = 0.5 * (  za * ( zts(iid,jj,jp_tem) - zts(iis,jj,jp_tem) )    &
                      &            - zb * ( zts(iid,jj,jp_sal) - zts(iis,jj,jp_sal) )  ) * umask(ji,jj,1)
-                  zgdrho = MAX( 0.e0, zgdrho )                               ! only if shelf is denser than deep
+                  zgdrho = MAX( 0._wp, zgdrho )                               ! only if shelf is denser than deep
                   !
                   !                                                          ! bbl transport (down-slope direction)
@@ -470,5 +469,5 @@
                   zgdrho = 0.5 * (  za * ( zts(ji,ijd,jp_tem) - zts(ji,ijs,jp_tem) )    &
                      &            - zb * ( zts(ji,ijd,jp_sal) - zts(ji,ijs,jp_sal) )  ) * vmask(ji,jj,1)
-                  zgdrho = MAX( 0.e0, zgdrho )                               ! only if shelf is denser than deep
+                  zgdrho = MAX( 0._wp, zgdrho )                               ! only if shelf is denser than deep
                   !
                   !                                                          ! bbl transport (down-slope direction)
@@ -549,6 +548,6 @@
       DO jj = 1, jpjm1
          DO ji = 1, jpim1
-            mgrhu(ji,jj) = INT(  SIGN( 1.e0, gdept_0(ji+1,jj,mbkt(ji+1,jj)) - gdept_0(ji,jj,mbkt(ji,jj)) )  )
-            mgrhv(ji,jj) = INT(  SIGN( 1.e0, gdept_0(ji,jj+1,mbkt(ji,jj+1)) - gdept_0(ji,jj,mbkt(ji,jj)) )  )
+            mgrhu(ji,jj) = INT(  SIGN( 1._wp, gdept_0(ji+1,jj,mbkt(ji+1,jj)) - gdept_0(ji,jj,mbkt(ji,jj)) )  )
+            mgrhv(ji,jj) = INT(  SIGN( 1._wp, gdept_0(ji,jj+1,mbkt(ji,jj+1)) - gdept_0(ji,jj,mbkt(ji,jj)) )  )
          END DO
       END DO
@@ -573,17 +572,17 @@
             ij0 = 102   ;   ij1 = 102              ! Gibraltar enhancement of BBL
             ii0 = 139   ;   ii1 = 140
-            ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) =  4.e0*ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
-            ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) =  4.e0*ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
+            ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) =  4._wp*ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
+            ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) =  4._wp*ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
             !
             ij0 =  88   ;   ij1 =  88              ! Red Sea enhancement of BBL
             ii0 = 161   ;   ii1 = 162
-            ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) = 10.e0*ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
-            ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) = 10.e0*ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
+            ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) = 10._wp*ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
+            ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) = 10._wp*ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
             !
          CASE ( 4 )                          ! ORCA_R4
             ij0 =  52   ;   ij1 =  52              ! Gibraltar enhancement of BBL
             ii0 =  70   ;   ii1 =  71
-            ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) =  4.e0*ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
-            ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) =  4.e0*ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
+            ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) =  4._wp*ahu_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
+            ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1)) =  4._wp*ahv_bbl_0(mi0(ii0):mi1(ii1),mj0(ij0):mj1(ij1))
          END SELECT
          !
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/traldf.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/traldf.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/traldf.F90	(revision 6851)
@@ -178,4 +178,6 @@
       IF( ln_ldfeiv .AND. .NOT.( ln_traldf_iso .OR. ln_traldf_triad ) )                                    &
            &            CALL ctl_stop( 'eddy induced velocity on tracers requires iso-neutral laplacian diffusion' )
+      IF( ln_isfcav .AND. ln_traldf_triad ) &
+           &            CALL ctl_stop( ' ice shelf cavity and traldf_triad not tested' )
            !
       IF(  nldf == np_lap_i .OR. nldf == np_lap_it .OR. &
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 6851)
@@ -11,6 +11,6 @@
    !!            3.2  !  2009-04  (G. Madec & NEMO team) 
    !!            3.6  !  2012-05  (C. Rousset) store attenuation coef for use in ice model 
-   !!             -   !  2015-12  (O. Aumont, J. Jouanno, C. Ethe) use vertical profile of chlorophyll
-   !!            3.7  !  2016-01  (G. Madec, A. Coward)  remove optimisation for fix volume 
+   !!            3.6  !  2015-12  (O. Aumont, J. Jouanno, C. Ethe) use vertical profile of chlorophyll
+   !!            3.7  !  2015-11  (G. Madec, A. Coward)  remove optimisation for fix volume 
    !!----------------------------------------------------------------------
 
@@ -56,16 +56,15 @@
    INTEGER , PUBLIC ::   nksr         !: levels below which the light cannot penetrate (depth larger than 391 m)
  
-   INTEGER, PARAMETER ::   np_RGB    = 1   ! R-G-B     light penetration with constant Chlorophyll
-   INTEGER, PARAMETER ::   np_2BD    = 2   ! 2 bands   light penetration
-   INTEGER, PARAMETER ::   np_BIO    = 3   ! bio-model light penetration
+   INTEGER, PARAMETER ::   np_RGB  = 1   ! R-G-B     light penetration with constant Chlorophyll
+   INTEGER, PARAMETER ::   np_RGBc = 2   ! R-G-B     light penetration with Chlorophyll data
+   INTEGER, PARAMETER ::   np_2BD  = 3   ! 2 bands   light penetration
+   INTEGER, PARAMETER ::   np_BIO  = 4   ! bio-model light penetration
    !
    INTEGER  ::   nqsr    ! user choice of the type of light penetration
    REAL(wp) ::   xsi0r   ! inverse of rn_si0
    REAL(wp) ::   xsi1r   ! inverse of rn_si1
-   
-   REAL(wp) ::   rChl_0 = 0.05_wp   ! value of Chlorophyll used in case of constant Chlorophyll
    !
    REAL(wp) , DIMENSION(3,61)           ::   rkrgb    ! tabulated attenuation coefficients for RGB absorption
-   TYPE(FLD), DIMENSION(:), ALLOCATABLE ::   sf_chl   ! structure of input Chl (file informations, fields read)
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_chl   ! structure of input Chl (file informations, fields read)
 
    !! * Substitutions
@@ -110,10 +109,11 @@
       REAL(wp) ::   zchl, zcoef, z1_2        ! local scalars
       REAL(wp) ::   zc0 , zc1 , zc2 , zc3    !    -         -
+      REAL(wp) ::   zzc0, zzc1, zzc2, zzc3   !    -         -
       REAL(wp) ::   zz0 , zz1                !    -         -
-      REAL(wp) ::   zCb, zCmax, zze, z1_ze, zpsi, zpsimax, zdelpsi, zCtot, zCze
+      REAL(wp) ::   zCb, zCmax, zze, zpsi, zpsimax, zdelpsi, zCtot, zCze
       REAL(wp) ::   zlogc, zlogc2, zlogc3 
       REAL(wp), POINTER, DIMENSION(:,:)   :: zekb, zekg, zekr
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ze0, ze1, ze2, ze3, zea, zchl3d, ztrdt
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zetot
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: ze0, ze1, ze2, ze3, zea, ztrdt
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zetot, zchl3d
       !!----------------------------------------------------------------------
       !
@@ -153,5 +153,5 @@
       !                         !--------------------------------!
       !
-      CASE( np_BIO )                !==  bio-model fluxes  ==!
+      CASE( np_BIO )                   !==  bio-model fluxes  ==!
          !
          DO jk = 1, nksr
@@ -159,54 +159,39 @@
          END DO
          !
-      CASE( np_RGB )                !==  R-G-B fluxes  ==!
+      CASE( np_RGB , np_RGBc )         !==  R-G-B fluxes  ==!
          !
          CALL wrk_alloc( jpi,jpj,       zekb, zekg, zekr                ) 
          CALL wrk_alloc( jpi,jpj,jpk,   ze0, ze1, ze2, ze3, zea, zchl3d ) 
          !
-         SELECT CASE( nn_chldta )         ! set 3D chlorophyll field
-         !
-         CASE( 0 )                           ! constant 
+         IF( nqsr == np_RGBc ) THEN          !*  Variable Chlorophyll
+            CALL fld_read( kt, 1, sf_chl )         ! Read Chl data and provides it at the current time step
             DO jk = 1, nksr + 1
-               zchl3d(:,:,jk) = rChl_0
-            END DO
-            !
-         CASE( 1 )                           ! surface chlorophyl data spread uniformly on the vertical
-            CALL fld_read( kt, 1, sf_chl )         ! Read Chl data and provides it at the current time step
-            DO jk = 1, nksr + 1                    ! uniform vertical profile
-               zchl3d(:,:,jk) = sf_chl(1)%fnow(:,:,1) 
-            END DO
-            !
-         CASE( 2 )                           ! surface chlorophyl data + Morel and Berthon (1989) profile
-            CALL fld_read( kt, 1, sf_chl )         ! Read Chl data and provides it at the current time step
-            DO jj = 2, jpjm1                       ! Chl profile = F( surface Chl value)
-               DO ji = fs_2, fs_jpim1
-                  zchl    = sf_chl(1)%fnow(ji,jj,1)
-                  zCtot   =  40.6_wp *  zchl**0.459
-                  zze     = 568.2_wp * zCtot**(-0.746)
-                  IF( zze > 102. )   zze = 200.0 * zCtot**(-0.293)
-                  zlogc   = LOG( zchl )
-!!gm : instead of this :
-                  zlogc2  = zlogc * zlogc
-                  zlogc3  = zlogc * zlogc * zlogc
-                  zCb     = 0.768 + 0.087 * zlogc - 0.179 * zlogc2 - 0.025 * zlogc3
-                  zCmax   = 0.299 - 0.289 * zlogc + 0.579 * zlogc2
-                  zpsimax = 0.6   - 0.640 * zlogc + 0.021 * zlogc2 + 0.115 * zlogc3
-                  zdelpsi = 0.710 + 0.159 * zlogc + 0.021 * zlogc2
-!!gm faster & more precise:
-!                  zCb     = 0.768 + zlogc * (  (  0.087 + zlogc * (- 0.179 - zlogc * 0.025 )  )
-!                  zCmax   = 0.299 + zlogc * (   - 0.289 + zlogc *    0.579  )
-!                  zpsimax = 0.6   + zlogc * (  (- 0.640 + zlogc * (  0.021 + zlogc * 0.115 )  )
-!                  zdelpsi = 0.710 + zlogc * (     0.159 + zlogc *    0.021  )
-!!gm end          
-                  zCze    = 1.12_wp * (zchl)**0.803 
-                  z1_ze   = 1._wp / zze
-                  DO jk = 1, nksr + 1
-                     zpsi = gdept_n(ji,jj,jk) * z1_ze
+               DO jj = 2, jpjm1                       ! Separation in R-G-B depending of the surface Chl
+                  DO ji = fs_2, fs_jpim1
+                     zchl    = sf_chl(1)%fnow(ji,jj,1)
+                     zCtot   = 40.6  * zchl**0.459
+                     zze     = 568.2 * zCtot**(-0.746)
+                     IF( zze > 102. ) zze = 200.0 * zCtot**(-0.293)
+                     zpsi    = gdepw_n(ji,jj,jk) / zze
+                     !
+                     zlogc   = LOG( zchl )
+                     zlogc2  = zlogc * zlogc
+                     zlogc3  = zlogc * zlogc * zlogc
+                     zCb     = 0.768 + 0.087 * zlogc - 0.179 * zlogc2 - 0.025 * zlogc3
+                     zCmax   = 0.299 - 0.289 * zlogc + 0.579 * zlogc2
+                     zpsimax = 0.6   - 0.640 * zlogc + 0.021 * zlogc2 + 0.115 * zlogc3
+                     zdelpsi = 0.710 + 0.159 * zlogc + 0.021 * zlogc2
+                     zCze    = 1.12  * (zchl)**0.803 
+                     !
                      zchl3d(ji,jj,jk) = zCze * ( zCb + zCmax * EXP( -( (zpsi - zpsimax) / zdelpsi )**2 ) )
                   END DO
+                  !
                END DO
             END DO
-            !
-         END SELECT
+         ELSE                                !* constant chrlorophyll
+           DO jk = 1, nksr + 1
+              zchl3d(:,:,jk) = 0.05 
+            ENDDO
+         ENDIF
          !
          zcoef  = ( 1. - rn_abs ) / 3._wp    !* surface equi-partition in R-G-B
@@ -221,9 +206,9 @@
          END DO
          !
-         DO jk = 2, nksr+1                   !* interior partition in R-G-B function of 3D Chl
+         DO jk = 2, nksr+1                   !* interior equi-partition in R-G-B depending of vertical profile of Chl
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1
-                  zchl = MIN( 10._wp , MAX( 0.03_wp , zchl3d(ji,jj,jk) ) )
-                  irgb = NINT( 41._wp + 20._wp * LOG10(zchl) + 1.e-15 )
+                  zchl = MIN( 10. , MAX( 0.03, zchl3d(ji,jj,jk) ) )
+                  irgb = NINT( 41 + 20.*LOG10(zchl) + 1.e-15 )
                   zekb(ji,jj) = rkrgb(1,irgb)
                   zekg(ji,jj) = rkrgb(2,irgb)
@@ -231,4 +216,5 @@
                END DO
             END DO
+
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1
@@ -254,5 +240,5 @@
          END DO
          !
-         CALL wrk_dealloc( jpi,jpj,       zekb, zekg, zekr                ) 
+         CALL wrk_dealloc( jpi,jpj,        zekb, zekg, zekr               ) 
          CALL wrk_dealloc( jpi,jpj,jpk,   ze0, ze1, ze2, ze3, zea, zchl3d ) 
          !
@@ -344,6 +330,4 @@
       INTEGER  ::   ji, jj, jk                  ! dummy loop indices
       INTEGER  ::   ios, irgb, ierror, ioptio   ! local integer
-!      REAL(wp) ::   zz0, zc0 , zc1, zcoef      ! local scalars
-!      REAL(wp) ::   zz1, zc2 , zc3, zchl       !   -      -
       !
       CHARACTER(len=100) ::   cn_dir   ! Root directory for location of ssr files
@@ -374,5 +358,5 @@
          WRITE(numout,*) '      bio-model            light penetration       ln_qsr_bio = ', ln_qsr_bio
          WRITE(numout,*) '      light penetration for ice-model (LIM3)       ln_qsr_ice = ', ln_qsr_ice
-         WRITE(numout,*) '      RGB : Chl data (=1,2) or cst value (=0)      nn_chldta  = ', nn_chldta
+         WRITE(numout,*) '      RGB : Chl data (=1) or cst value (=0)        nn_chldta  = ', nn_chldta
          WRITE(numout,*) '      RGB & 2 bands: fraction of light (rn_si1)    rn_abs     = ', rn_abs
          WRITE(numout,*) '      RGB & 2 bands: shortess depth of extinction  rn_si0     = ', rn_si0
@@ -390,4 +374,5 @@
       !
       IF( ln_qsr_rgb .AND. nn_chldta == 0 )   nqsr = np_RGB 
+      IF( ln_qsr_rgb .AND. nn_chldta == 1 )   nqsr = np_RGBc
       IF( ln_qsr_2bd                      )   nqsr = np_2BD
       IF( ln_qsr_bio                      )   nqsr = np_BIO
@@ -399,5 +384,5 @@
       SELECT CASE( nqsr )
       !                               
-      CASE( np_RGB )             !==  Red-Green-Blue light penetration  ==!
+      CASE( np_RGB , np_RGBc )         !==  Red-Green-Blue light penetration  ==!
          !                             
          IF(lwp)   WRITE(numout,*) '   R-G-B   light penetration '
@@ -409,11 +394,6 @@
          IF(lwp) WRITE(numout,*) '        level of light extinction = ', nksr, ' ref depth = ', gdepw_1d(nksr+1), ' m'
          !
-         SELECT CASE( nn_chldta )         ! set 3D chlorophyll field
-         CASE( 0 )                           ! constant
-            IF(lwp) WRITE(numout,*) '        constant Chlorophyll set to rChl_0 =', rChl_0 
-            !
-         CASE( 1 , 2 )                       ! 3D chlorophyl field : read 2D surface data
-            !
-            IF(lwp) WRITE(numout,*) '        surface 2D Chlorophyll field read in a file'
+         IF( nqsr == np_RGBc ) THEN                ! Chl data : set sf_chl structure
+            IF(lwp) WRITE(numout,*) '        Chlorophyll read in a file'
             ALLOCATE( sf_chl(1), STAT=ierror )
             IF( ierror > 0 ) THEN
@@ -425,11 +405,10 @@
             CALL fld_fill( sf_chl, (/ sn_chl /), cn_dir, 'tra_qsr_init',   &
                &           'Solar penetration function of read chlorophyll', 'namtra_qsr' )
-            !
-            IF( lwp .AND. nn_chldta == 1 )   WRITE(numout,*) '        profile of chlorophyll : Chl(z) = Chl(z=0)'
-            IF( lwp .AND. nn_chldta == 2 )   WRITE(numout,*) '        profile of chlorophyll : Chl(z) = Func[Chl(z=0)]'
-            !
-         END SELECT
-         !
-      CASE( np_2BD )             !==  2 bands light penetration  ==!
+         ENDIF
+         IF( nqsr == np_RGB ) THEN                 ! constant Chl
+            IF(lwp) WRITE(numout,*) '        Constant Chlorophyll concentration = 0.05'
+         ENDIF
+         !
+      CASE( np_2BD )                   !==  2 bands light penetration  ==!
          !
          IF(lwp)  WRITE(numout,*) '   2 bands light penetration'
@@ -438,5 +417,5 @@
          IF(lwp) WRITE(numout,*) '        level of light extinction = ', nksr, ' ref depth = ', gdepw_1d(nksr+1), ' m'
          !
-      CASE( np_BIO )                         !==  BIO light penetration  ==!
+      CASE( np_BIO )                   !==  BIO light penetration  ==!
          !
          IF(lwp) WRITE(numout,*) '   bio-model light penetration'
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/trasbc.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 6851)
@@ -207,4 +207,8 @@
          END DO  
       ENDIF
+
+      IF( iom_use('rnf_x_sst') )   CALL iom_put( "rnf_x_sst", rnf*tsn(:,:,1,jp_tem) )   ! runoff term on sst
+      IF( iom_use('rnf_x_sss') )   CALL iom_put( "rnf_x_sss", rnf*tsn(:,:,1,jp_sal) )   ! runoff term on sss
+
       !
       !----------------------------------------
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRD/trdken.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRD/trdken.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRD/trdken.F90	(revision 6851)
@@ -106,8 +106,8 @@
          DO jj = 2, jpj
             DO ji = 2, jpi
-               zke(ji,jj,jk) = 0.5_wp * rau0 *( un(ji  ,jj,jk) * putrd(ji  ,jj,jk) * bu(ji  ,jj,jk)  &
-                  &                           + un(ji-1,jj,jk) * putrd(ji-1,jj,jk) * bu(ji-1,jj,jk)  &
-                  &                           + vn(ji,jj  ,jk) * pvtrd(ji,jj  ,jk) * bv(ji,jj  ,jk)  &
-                  &                           + vn(ji,jj-1,jk) * pvtrd(ji,jj-1,jk) * bv(ji,jj-1,jk)  ) * r1_bt(ji,jj,jk)
+               zke(ji,jj,jk) = 0.25_wp * rau0 * (  un(ji  ,jj,jk) * putrd(ji  ,jj,jk) * bu(ji  ,jj,jk)  &
+                  &                              + un(ji-1,jj,jk) * putrd(ji-1,jj,jk) * bu(ji-1,jj,jk)  &
+                  &                              + vn(ji,jj  ,jk) * pvtrd(ji,jj  ,jk) * bv(ji,jj  ,jk)  &
+                  &                              + vn(ji,jj-1,jk) * pvtrd(ji,jj-1,jk) * bv(ji,jj-1,jk)  ) * r1_bt(ji,jj,jk)
             END DO
          END DO
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 6851)
@@ -31,5 +31,5 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmld    !: mixing layer depth (turbocline)      [m]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmlp    !: mixed layer depth  (rho=rho0+zdcrit) [m]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmlpt   !: depth of the last T-point inside the mixed layer
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmlpt   !: depth of the last T-point inside the mixed layer [m]
 
    REAL(wp), PUBLIC ::   rho_c = 0.01_wp    !: density criterion for mixed layer depth
@@ -77,7 +77,7 @@
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !
-      INTEGER  ::   ji, jj, jk   ! dummy loop indices
-      INTEGER  ::   iikn, iiki, ikt   ! local integer
-      REAL(wp) ::   zN2_c        ! local scalar
+      INTEGER  ::   ji, jj, jk      ! dummy loop indices
+      INTEGER  ::   iikn, iiki, ikt ! local integer
+      REAL(wp) ::   zN2_c           ! local scalar
       INTEGER, POINTER, DIMENSION(:,:) ::   imld   ! 2D workspace
       !!----------------------------------------------------------------------
@@ -130,10 +130,12 @@
       IF( .NOT.lk_offline ) THEN            ! no need to output in offline mode
          IF ( iom_use("mldr10_1") ) THEN
-            IF( .NOT. ln_isfcav ) CALL iom_put( "mldr10_1", hmlp )            ! mixed layer depth
-            IF(       ln_isfcav ) CALL iom_put( "mldr10_1", hmlp - risfdep)   ! mixed layer thickness
+            IF( ln_isfcav ) THEN   ;   CALL iom_put( "mldr10_1", hmlp - risfdep)   ! mixed layer thickness
+            ELSE                   ;   CALL iom_put( "mldr10_1", hmlp )            ! mixed layer depth
+            END IF
          END IF
          IF ( iom_use("mldkz5") ) THEN
-            IF( .NOT. ln_isfcav ) CALL iom_put( "mldkz5"  , hmld )             ! turbocline depth
-            IF(       ln_isfcav ) CALL iom_put( "mldkz5"  , hmld - risfdep )   ! turbocline thickness
+            IF( ln_isfcav ) THEN   ;   CALL iom_put( "mldkz5"  , hmld - risfdep )   ! turbocline thickness
+            ELSE                   ;   CALL iom_put( "mldkz5"  , hmld )             ! turbocline depth
+            END IF
          END IF
       ENDIF
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 6851)
@@ -31,5 +31,5 @@
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
-   USE eosbn2, ONLY : nn_eos
+   USE eosbn2, ONLY : neos
 
    IMPLICIT NONE
@@ -175,5 +175,8 @@
       !  Compute Ekman depth from wind stress forcing.
       ! -------------------------------------------------------
-      zflageos = ( 0.5 + SIGN( 0.5, nn_eos - 1. ) ) * rau0
+!!gm small bug : boussinesq equation of the ocean model
+!!gm             therefore rau0 should be used not the potential surface density...
+!!gm             ===>>>>   zrhos = rau0  in the epression below, and the rsmall is useless in zustar calculation
+      zflageos = ( 0.5 + SIGN( 0.5, neos - 1. ) ) * rau0
       DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1
